/* rstd v1.1, (c) 2000 Robert Salizar (madcamel@energymech.net)
 * This code is distributed under the propritary MCL license,
 * please read LICENSE */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <time.h>
#include <signal.h>

#ifndef __FAVOR_BSD
# define __FAVOR_BSD
#endif
#include <netinet/tcp.h>
#ifndef __USE_BSD
# define __USE_BSD
#endif
#include <netinet/ip.h>

#ifndef CFGFILE
# define CFGFILE "\"/etc/rstd.conf\""
#endif
#define PERR(x)        { perror(x); exit(1); }

struct tcpopt_hdr {
  u_char  type;
  u_char  len;
  u_short value;
};

struct pseudo_hdr
{
  u_long saddr, daddr;
  u_char mbz, ptcl;
  u_short tcpl;
};

struct packet
{
  struct ip ip;
  struct tcphdr tcp;
  struct tcpopt_hdr opt;
};

struct cksum
{
  struct pseudo_hdr pseudo;
  struct tcphdr tcp;
};

u_short in_cksum (u_short * addr, int len)
{
	register int nleft = len;
	register int sum = 0;                     
	u_short *w = addr;
	u_short answer = 0;

	while (nleft > 1)
	{
		sum += *w++;
		nleft -= 2;
	}
	if (nleft == 1)
	{
		*(u_char *) (&answer) = *(u_char *) w;
		sum += answer;                        
	}
	sum = (sum >> 16) + (sum & 0xffff);
	sum += (sum >> 16);
	answer = ~sum;
	return(answer);
}
